%define tarball xf86-video-mga
%define moduledir %(pkg-config xorg-server --variable=moduledir )
%define driverdir	%{moduledir}/drivers

%define gitdate 20080102

Summary:   Xorg X11 mga video driver
Name:      xorg-x11-drv-mga
Version:   1.6.3
Release:   9%{?dist}
URL:       http://www.x.org
License: MIT
Group:     User Interface/X Hardware Support

Source0:   http://x.org/pub/individual/driver/%{tarball}-%{version}.tar.bz2
#Source0:    %{tarball}-%{gitdate}.tar.bz2
Source1:    mga.xinf

# this is not upstream's mga driver, yet.  git tree available here:
# http://cgit.freedesktop.org/git/xorg/driver/xf86-video-mga/log/?h=g200se-randr-v2
# patch generated by:
# % git diff-tree -p xf86-video-mga-1.6.3..49eda2fe > g200se-randr-v2.patch
Patch0: g200se-randr-v2.patch
Patch4: mga-1.6.1-no-rr13-panning.patch
Patch5: mga-shadow.patch
Patch6: mga-1.6.3-g200se-a-16bpp.patch
Patch7: mga-1.6.3-shadow-height.patch
Patch8: 0001-dri-Stop-uselessly-initializing-the-ValidateTree-hoo.patch
Patch9: 0001-Enable-write-combining-on-the-framebuffer-BAR.patch
Patch10: mga-1.6.3-g200ew3.patch
Patch11: mga-1.6.3-g200e4.patch

ExcludeArch: s390 s390x

BuildRequires: autoconf automake libtool
BuildRequires: xorg-x11-server-sdk >= 1.13.0
BuildRequires: mesa-libGL-devel >= 6.4-4
BuildRequires: libdrm-devel >= 2.0-1

Requires:  hwdata
Requires:  Xorg %(xserver-sdk-abi-requires ansic)
Requires:  Xorg %(xserver-sdk-abi-requires videodrv)

%description 
X.Org X11 mga video driver.

%prep
%setup -q -n %{tarball}-%{version}
%patch0 -p1 -b .randr
%patch4 -p1 -b .no-panning
%patch5 -p1 -b .shadow
%patch6 -p1 -b .16bpp
%patch7 -p1 -b .height
%patch8 -p1 -b .dri
%patch9 -p1 -b .wc
%patch10 -p1 -b .g200ew3
%patch11 -p1 -b .g200e4

%build
autoreconf -f -v --install || exit 1
%configure --disable-static
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases/

find $RPM_BUILD_ROOT -regex ".*\.la$" | xargs rm -f --

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{driverdir}/mga_drv.so
%{_datadir}/hwdata/videoaliases/mga.xinf
%{_mandir}/man4/mga.4*

%changelog
* Wed Jan 20 2016 Adam Jackson <ajax@redhat.com> 1.6.3-9
- Add support for G200EW3 and G200E4

* Wed Nov 18 2015 Adam Jackson <ajax@redhat.com> 1.6.3-8
- Enable write-combining on the framebuffer BAR

* Wed Nov 11 2015 Adam Jackson <ajax@redhat.com> 1.6.3-7
- Rebuild for server 1.17

* Wed Mar 04 2015 Adam Jackson <ajax@redhat.com> 1.6.3-6
- When defaulting to 16bpp, don't override the config file

* Mon Aug 25 2014 Adam Jackson <ajax@redhat.com> 1.6.3-5
- Fix shadow framebuffer height

* Mon Aug 25 2014 Adam Jackson <ajax@redhat.com> 1.6.3-4
- Default to 16bpp on G200SE-A
- Port to shadow from shadowfb for performance

* Wed May 21 2014 Adam Jackson <ajax@redhat.com> 1.6.3-1
- New upstream branch based on 1.6.3, with various RHEL patches merged

* Wed Apr 23 2014 Adam Jackson <ajax@redhat.com> 1.6.1-11
- Rebuild for server 1.15

* Tue Jul 23 2013 Adam Jackson <ajax@redhat.com> 1.6.1-10
- mga-1.6.1-char-cell-modes.patch: Filter out modes whose horizontal timings
  aren't character-cell aligned on G200SE and friends (#894959)

* Mon Jul 22 2013 Adam Jackson <ajax@redhat.com> 1.6.1-9
- mga-1.6.1-size-range.patch: Fix large resolutions on G200SE &c (#918017)

* Tue Dec 11 2012 Adam Jackson <ajax@redhat.com> 1.6.1-7
- mga-1.6.1-shadowfb-clip.patch: Fix clipping in shadow upload (#877071)

* Mon Oct 01 2012 Adam Jackson <ajax@redhat.com> 1.6.1-5
- mga-1.6.1-no-rr13-panning.patch: Disable RANDR 1.3 panning (#821551)

* Fri Sep 28 2012 Dave Airlie <airlied@redhat.com> 1.6.1-4
- fix mga DRI1 regression since XAA removal

* Wed Sep 26 2012 Dave Airlie <airlied@redhat.com> 1.6.1-3
- fix so mga driver loads properly

* Wed Aug 22 2012 airlied@redhat.com - 1.6.1-2
- rebuild for server ABI requires

* Tue Aug 07 2012 Dave Airlie <airlied@redhat.com> 1.6.1-1
- rebase to upstream 1.6.1 release with randr 1.2 on top

* Fri May 18 2012 Adam Jackson <ajax@redhat.com> 1.4.13-7
- randr-dpms-fix.patch: Fix DPMS on EV and others (#821956)

* Wed Apr 25 2012 Adam Jackson <ajax@redhat.com> 1.4.13-6
- Fix rendering corruption on RANDR-enabled setups (#814381)
- Fix display setup on G200ER (#810224)

* Fri Feb 24 2012 Adam Jackson <ajax@redhat.com> 1.4.13-4
- Add RANDR 1.2 support for G200xx chips. (#657580)

* Tue Oct 18 2011 Adam Jackson <ajax@redhat.com> 1.4.13-3
- mga-1.4.13-g200er-tagfifo.patch: Reset tag FIFO after mode switch on
  G200ER. (#745080)

* Thu Aug 18 2011 Adam Jackson <ajax@redhat.com> 1.4.13-2
- mga-1.4.13-git.patch: Sync with git for Pilot 3 support. (#526104)

* Tue Jun 28 2011 Ben Skeggs <bskeggs@redhat.com> 1.4.13-1
- upstream release 1.4.13
- mga-1.4.12-g200er.patch: dropped, in upstream release

* Mon Jun 20 2011 Adam Jackson <ajax@redhat.com> 1.4.12-5
- mga-1.4.12-bigendian.patch: Don't clobber byte-swizzle setup on
  big-endian machines. (#713388)

* Thu Apr 07 2011 Adam Jackson <ajax@redhat.com> 1.4.12-4
- mga-1.4.12-default-mode.patch: Also clip maximum dotclock when G200SE and
  no DDC. (#627719)

* Tue Feb 08 2011 Adam Jackson <ajax@redhat.com> 1.4.12-3
- mga-1.4.12-g200er.patch: Add G200ER support (#674556, #672813, #660630)
- mga.xinf: Add G200ER

* Thu Jun 24 2010 Adam Jackson <ajax@redhat.com> 1.4.12-2
- mga-1.4.10-g200se-24-not-32.patch: Prefer 24bpp on G200SE-A (#607093)

* Tue May 18 2010 Adam Jackson <ajax@redhat.com> 1.4.12-1
- mga 1.4.12 (#517924)
- mga.xinf: Update to match.

* Mon Nov 30 2009 Dennis Gregorovic <dgregor@redhat.com> - 1.4.11-1.1
- Rebuilt for RHEL 6

* Tue Aug 04 2009 Dave Airlie <airlied@redhat.com> 1.4.11-1
- mga 1.4.11

* Mon Jul 27 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.10-3.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul 15 2009 Adam Jackson <ajax@redhat.com> - 1.4.10-2.1
- ABI bump

* Tue Jun 23 2009 Dave Airlie <airlied@redhat.com> 1.4.10-2
- fixup ABI for rawhide

* Mon Apr 27 2009 Adam Jackson <ajax@redhat.com> 1.4.10-1
- mga 1.4.10

* Tue Feb 24 2009 Adam Jackson <ajax@redhat.com> 1.4.9-2
- Fix ftbfs

* Sun Feb 08 2009 Adam Jackson <ajax@redhat.com> 1.4.9-1
- mga 1.4.9

* Mon Dec 22 2008 Dave Airlie <airlied@redhat.com> 1.4.8-2
- bump for server API change

* Fri Feb 22 2008 Adam Jackson <ajax@redhat.com> 1.4.8-1
- mga 1.4.8

* Wed Feb 20 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.4.7-2.20080102
- Autorebuild for GCC 4.3

* Wed Jan 09 2008 Adam Jackson <ajax@redhat.com> 1.4.7-1.20080102
- Rebuild for new server ABI.

* Wed Jan 02 2008 Adam Jackson <ajax@redhat.com> 1.4.7-0.20080102
- Today's git snapshot for pciaccess goodness.
- mga-1.4.7-death-to-cfb.patch: Remove what little cfb support there was.
- mga-1.4.7-alloca.patch: Fix ALLOCATE_LOCAL references.

* Wed Aug 22 2007 Adam Jackson <ajax@redhat.com> - 1.4.6.1-6
- Rebuild for PPC toolchain bug

* Wed Jun 27 2007 Adam Jackson <ajax@redhat.com> 1.4.6.1-5
- Use %%{?_smp_mflags}.

* Mon Jun 18 2007 Adam Jackson <ajax@redhat.com> 1.4.6.1-4
- Update Requires and BuildRequires.  Add Requires: hwdata.

* Mon Feb 26 2007 Adam Jackson <ajax@redhat.com> 1.4.6.1-3
- Late-bind a call into a loadable module
- Disown the module directory

* Fri Feb 16 2007 Adam Jackson <ajax@redhat.com> 1.4.6.1-2
- ExclusiveArch -> ExcludeArch
- DRI on all arches

* Fri Jan 05 2007 Adam Jackson <ajax@redhat.com> 1.4.6.1-1
- Update to 1.4.6.1

* Mon Dec 4 2006 Adam Jackson <ajax@redhat.com> 1.4.5-2
- mga-1.4.5-no-hal-advertising.patch: Don't link to the HAL module as it's
  non-free.

* Fri Dec 1 2006 Adam Jackson <ajax@redhat.com> 1.4.5-1
- Update to 1.4.5.

* Fri Aug 18 2006 Kristian Høgsberg <krh@redhat.com> 1.4.1-5.fc6
- Add Tilman Sauerbecks patch to fix DRI locking.

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> 1.4.1-4.1
- rebuild

* Thu Jul  6 2006 Adam Jackson <ajackson@redhat.com> 1.4.1-4
- mga.xinf updates.  Add G200SE cards, remove Impression and Mistral IDs
  (since they do not and never have worked), and comment each line with
  the appropriate card name.

* Fri May 26 2006 Mike A. Harris <mharris@redhat.com> 1.4.1-3
- Added with_dri conditionalization (not yet working for non-dri case).
- Added "BuildRequires: libdrm-devel >= 2.0-1" for (#192358).
- Added "BuildRequires: mesa-libGL-devel >= 6.4-4".
- Bumped sdk dep to pick up proto-devel indirectly.

* Sun Apr  9 2006 Adam Jackson <ajackson@redhat.com> 1.4.1-2
- Update to 1.4.1 from 7.1RC1.

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> 1.2.1.3-1.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> 1.2.1.3-1.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Wed Jan 18 2006 Mike A. Harris <mharris@redhat.com> 1.2.1.3-1
- Updated xorg-x11-drv-mga to version 1.2.1.3 from X11R7.0

* Tue Dec 20 2005 Mike A. Harris <mharris@redhat.com> 1.2.1.2-1
- Updated xorg-x11-drv-mga to version 1.2.1.2 from X11R7 RC4
- Removed 'x' suffix from manpage dirs to match RC4 upstream.

* Wed Nov 16 2005 Mike A. Harris <mharris@redhat.com> 1.2.1-1
- Updated xorg-x11-drv-mga to version 1.2.1 from X11R7 RC2

* Fri Nov 4 2005 Mike A. Harris <mharris@redhat.com> 1.2.0.1-1
- Updated xorg-x11-drv-mga to version 1.2.0.1 from X11R7 RC1
- Fix *.la file removal.
- Remove hardware specific {_bindir}/stormdwg utility.

* Mon Oct 3 2005 Mike A. Harris <mharris@redhat.com> 1.1.2-1
- Update BuildRoot to use Fedora Packaging Guidelines.
- Deglob file manifest.
- Limit "ExclusiveArch" to x86, x86_64, ia64, ppc

* Fri Sep 2 2005 Mike A. Harris <mharris@redhat.com> 1.1.2-0
- Initial spec file for mga video driver generated automatically
  by my xorg-driverspecgen script.
